#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <string.h>
#include <X11/Xlib.h>
#include <X11/extensions/XShm.h>
#include <X11/keysym.h>

#include "x-basics.h"
#include "x-events.h"
#include "x-image.h"
#include "graymap.h"
#include "btn.h"

int btn_click
       (Window window, ximage_t *image,
        const int *pos, int npos, XButtonEvent *event, int *stor)
{
  int i;
  const int *end;

  if (event->button!=Button1) goto fail;
  end= pos+npos;
  while(pos+4<end)
  {
    if (event->x>=pos[0] && event->y>=pos[1] && event->x<pos[0]+pos[2] &&
        event->y<pos[1]+pos[3]) 
    {
       for(i=0;i<5;i++) stor[i]= pos[i];
       xor_rect(image->data, image->width, image->height,
                             pos[0], pos[1], pos[2], pos[3], 0xffffff);
       XClearArea(x_display, window, pos[0], pos[1], pos[2], pos[3], True);
       return 1;
    }
    pos+= 5;
  }
fail:
  for(i=0;i<5;i++) stor[i]= -1;
  return 0;
}

int btn_release(Window window, ximage_t *image,
                XButtonEvent *event, int *stor)
{
  if (event->button!=Button1) return -1;
  if (stor[0]==-1) return -1;
  xor_rect(image->data, image->width, image->height,
                        stor[0], stor[1], stor[2], stor[3], 0xffffff);
  XClearArea(x_display, window, stor[0], stor[1], stor[2], stor[3], True);
  return stor[4];
}


