#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "pngio.h"

char *icons[]=
{
"cat-accessories.png",
"cat-development.png",
"cat-games.png",
"cat-graphics.png",
"cat-internet.png",
"cat-multimedia.png",
"cat-office.png",
"cat-other.png",
"cat-settings.png",
"cat-system.png",
"self-settings.png",
"default-button.png",
"folder.png",
NULL
};


int main(int argc,char **argv)
{
  unsigned int *data, w,h,i,j;
  FILE *f;
  char *e;

  f= fopen("../build/bico.c", "w");
  if (!f)
     exit(fprintf(stderr,"can't open ../build/bico.c\n"));
  fprintf(f,"#include <string.h>\n");
  fprintf(f,"int load_builtin_icon(char *name, unsigned int *Rw,\n"
            "                      unsigned int *Rh, unsigned int **Rd)\n"
            "{\n");

  for(i=0;icons[i];i++)
  {
    e= read_png_image(icons[i], &w, &h, &data);
    if (e) 
       exit(fprintf(stderr,"can't read image: %s\n",e));
    fprintf(f,"  static const unsigned int img%d[]={\n", i);
    for(j=0;j<w*h;j++)
    {
     fprintf(f,"0x%x,", data[j]);
     if ((j+1)%5==0) fprintf(f,"\n");
    }
    fprintf(f,"  };\n");
    fprintf(f,"  if (!strcmp(name,\":%s\"))\n"
              "     { *Rw= %d; *Rh= %d; *Rd= (unsigned int*) img%d; return 0; }\n", icons[i], w,h, i);
    free(data);
  }

  fprintf(f,"  return 1;\n}\n");
  fclose(f);
  return 0;
}
