#line 42 "bsd-licence-add.u"
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <libgen.h>

#line 8 "bsd-licence-add.u"
static const char hdr[]=
#line 11 "bsd-licence-add.c"
"/*\n"
"Copyright (c) %s.\n"
"\n"
"All rights reserved.\n"
"\n"
"Redistribution and use in source and binary forms, with or without\n"
"modification, are permitted provided that the following conditions\n"
"are met:\n"
"\n"
"1. Redistributions of source code must retain the above copyright notice,\n"
"   this list of conditions and the following disclaimer.\n"
"\n"
"2. Redistributions in binary form must reproduce the above copyright\n"
"   notice, this list of conditions and the following disclaimer in the\n"
"   documentation and/or other materials provided with the distribution.\n"
"\n"
"THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS\n"
"\042AS IS\042 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT\n"
"LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR\n"
"A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT\n"
"HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,\n"
"SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED\n"
"TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR\n"
"PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF\n"
"LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING\n"
"NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS\n"
"SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\n"
"*/\n"

#line 39 "bsd-licence-add.u"
;
#line 50 "bsd-licence-add.u"


int main(int argc,char **argv)
{
  char *stmt, *infn, *destdir;
  char outfn[2000];
  char *base;
  char buf[4096];
  int R;
  FILE *in,*out;
  
  if (argc!=4)
    exit(fprintf(stderr,"usage: %s 'year and author' input_file dest_dir\n",
                     argv[0]));
  stmt= argv[1];
  infn= argv[2];
  destdir= argv[3];

  base= basename(strdup(infn));
  sprintf(outfn,"%s/%s", destdir, base);

  out= fopen(outfn,"w");
  if (!out)
     exit(fprintf(stderr,"can't create %s: %s\n", outfn, strerror(errno)));
  fprintf(out, hdr, stmt);
  in= fopen(infn, "r");
  if (!in)
     exit(fprintf(stderr,"can't open %s: %s\n",infn, strerror(errno)));
  while((R=fread(buf, 1, sizeof(buf),in))>0)
      fwrite(buf, 1, R, out);
  fclose(in);
  fclose(out);
  return 0;
}
