#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <string.h>
#include <X11/Xlib.h>
#include <X11/extensions/XShm.h>

#include "x-basics.h"
#include "x-events.h"
#include "x-image.h"
#include "txtren.h"
#include "graymap.h"

static u_font_t *la_font;

void display_string_lxr(Window window, ximage_t *image,
                    const int *pos, char *str, uint32_t fg, uint32_t bg)
{
  uint32_t tw,th; uint8_t *te;
  int Ww,Wh;
  int sx, sy, cw, ch;

  if (!la_font) la_font= font_new(":default", 12);

  text_render(la_font, str, &tw, &te);
  th= la_font->height;

  Ww= pos[2]; Wh= pos[3];

  if (tw>Ww) { sx= tw- Ww; cw= Ww; }     else { sx= 0; cw= tw; }
  if (th>Wh) { sy= (th- Wh)/2; ch= Wh; } else { sy= 0; ch= th; }
  
  fill_rect(image->data, image->width, image->height,
            pos[0], pos[1], Ww, Wh, bg);

  graymap_draw(image->data, image->width, image->height, pos[0], pos[1],
               te, tw, th, sx, sy, fg, bg, cw, ch);
  free(te);

  XClearArea(x_display, window, pos[0], pos[1], Ww, Wh, True);
}

