#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "pngio.h"


int main(int argc,char **argv)
{
  char *fname;
  unsigned int *data, w,h,i;
  char *pfx;
  char *k,*e;

  fname= argv[1];
  pfx= strdup(fname);
  if (strlen(fname)<2) exit(fprintf(stderr,"bad file name %s\n",fname));
  if (strchr(pfx,'/'))
  {
     for(pfx+=strlen(pfx)-1;pfx[-1]!='/';pfx--) ;
  }
  k= strchr(pfx,'.');
  if (k) k[0]= 0;

  e= read_png_image(fname, &w, &h, &data);
  if (e) 
    exit(fprintf(stderr,"can't read image: %s\n",e));

  printf("static const unsigned int bi_%s_width=%d, bi_%s_height= %d;\n",
          pfx, w, pfx, h);
  printf("static const unsigned char bi_%s[]= {\n", pfx);
  for(i=0;i<w*h;i++)
  {
     printf("0x%02x,", (data[i]>>16)&0xff);
     if ((i+1)%12==0) printf("\n");
  }
  printf("};\n");
  fflush(stdout);
  return 0;
}
