#include <stdint.h>
#include <string.h>
#include <stdlib.h>
#include "pngio.h"
#include "resize_image.h"

int load_icon(char *file_name, int w,int h, 
              unsigned int *Rw, unsigned int *Rh, unsigned int **Rd)
{
  unsigned int Kw,Kh,*Kd;
  char *e;
  *Rw= 0; *Rh=0; *Rd= NULL;
  if (file_name[0]==':') return load_builtin_icon(file_name, Rw, Rh, Rd);

  e= read_png_image(file_name, &Kh, &Kw, &Kd);
  if (e) { free(e); return 1; }
  if (Kw>w || Kh>h)
  {
    if (!resize_image_argb(Kd, Kw, Kh, w,h, Rd, Rw, Rh))
       { free(Kd); return 0; }
  }
  *Rw= Kw; *Rh= Kh; *Rd= Kd;
  return 0;
}

